// Code generated by counterfeiter. DO NOT EDIT.
package loginfakes

import (
	"context"
	"sync"

	"gitlab.eclipse.org/eclipse/xfsc/tsa/login/internal/service/login"
)

type FakePolicy struct {
	TrustedEmailStub        func(context.Context, string) (bool, error)
	trustedEmailMutex       sync.RWMutex
	trustedEmailArgsForCall []struct {
		arg1 context.Context
		arg2 string
	}
	trustedEmailReturns struct {
		result1 bool
		result2 error
	}
	trustedEmailReturnsOnCall map[int]struct {
		result1 bool
		result2 error
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakePolicy) TrustedEmail(arg1 context.Context, arg2 string) (bool, error) {
	fake.trustedEmailMutex.Lock()
	ret, specificReturn := fake.trustedEmailReturnsOnCall[len(fake.trustedEmailArgsForCall)]
	fake.trustedEmailArgsForCall = append(fake.trustedEmailArgsForCall, struct {
		arg1 context.Context
		arg2 string
	}{arg1, arg2})
	stub := fake.TrustedEmailStub
	fakeReturns := fake.trustedEmailReturns
	fake.recordInvocation("TrustedEmail", []interface{}{arg1, arg2})
	fake.trustedEmailMutex.Unlock()
	if stub != nil {
		return stub(arg1, arg2)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakePolicy) TrustedEmailCallCount() int {
	fake.trustedEmailMutex.RLock()
	defer fake.trustedEmailMutex.RUnlock()
	return len(fake.trustedEmailArgsForCall)
}

func (fake *FakePolicy) TrustedEmailCalls(stub func(context.Context, string) (bool, error)) {
	fake.trustedEmailMutex.Lock()
	defer fake.trustedEmailMutex.Unlock()
	fake.TrustedEmailStub = stub
}

func (fake *FakePolicy) TrustedEmailArgsForCall(i int) (context.Context, string) {
	fake.trustedEmailMutex.RLock()
	defer fake.trustedEmailMutex.RUnlock()
	argsForCall := fake.trustedEmailArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2
}

func (fake *FakePolicy) TrustedEmailReturns(result1 bool, result2 error) {
	fake.trustedEmailMutex.Lock()
	defer fake.trustedEmailMutex.Unlock()
	fake.TrustedEmailStub = nil
	fake.trustedEmailReturns = struct {
		result1 bool
		result2 error
	}{result1, result2}
}

func (fake *FakePolicy) TrustedEmailReturnsOnCall(i int, result1 bool, result2 error) {
	fake.trustedEmailMutex.Lock()
	defer fake.trustedEmailMutex.Unlock()
	fake.TrustedEmailStub = nil
	if fake.trustedEmailReturnsOnCall == nil {
		fake.trustedEmailReturnsOnCall = make(map[int]struct {
			result1 bool
			result2 error
		})
	}
	fake.trustedEmailReturnsOnCall[i] = struct {
		result1 bool
		result2 error
	}{result1, result2}
}

func (fake *FakePolicy) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.trustedEmailMutex.RLock()
	defer fake.trustedEmailMutex.RUnlock()
	copiedInvocations := map[string][][]interface{}{}
	for key, value := range fake.invocations {
		copiedInvocations[key] = value
	}
	return copiedInvocations
}

func (fake *FakePolicy) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}

var _ login.Policy = new(FakePolicy)
